/*****************************************************************************
* Chuong trinh C2-1: Chuong trinh dao chuoi co cai dat stack                 *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define STACKSIZE 100
#define TRUE 1
#define FALSE 0

struct stack
{
   int top;
   char nodes[STACKSIZE];
};

int empty(struct stack *);
void push(struct stack *, char);
char pop(struct stack *);

main()
{
   struct stack s;
   char c, chuoi[STACKSIZE];
   int i, vitri;

   clrscr();

   do
   {
      s.top = -1;  // khoi tao stack
      vitri = 0;
      printf("%s", "\n\nChuoi ban nhap vao (0 de ket thuc): ");
      while((chuoi[vitri++] = getchar()) != '0');
      chuoi[--vitri] = '\0';

      // push chuoi vao stack
      for (i = 0; i < vitri; i++)
	      push(&s, chuoi[i]);

      printf("%s", "Chuoi dao la: ");
      // pop chuoi ra khoi stack
      while(!empty(&s))
	      printf("%c", pop(&s));

      printf("\n\nTiep tuc khong ? (c/k): ");
      c = getche();
   } while(c == 'c' || c == 'C');
   return(0);
}

int empty(struct stack *ps)
{
   if(ps->top == -1)
      return(TRUE);
   else
      return(FALSE);
}

/* hoac don gian hon:
int empty(struct stack *ps)
{
   return(ps->top == -1);
}
*/

void push(struct stack *ps, char x)
{
   if(ps->top == STACKSIZE-1)
   {
      printf("%s", "stack bi day");
      exit(1);
   }
   else
      ps->nodes[++(ps->top)] = x;
   return;
}

char pop(struct stack *ps)
{
   if(empty(ps))
   {
      printf("%s", "stack bi rong");
      exit(1);
   }
   return(ps->nodes[ps->top--]);
}