/*****************************************************************************
* Chuong trinh C7-4: Chuong trinh minh hoa Merge Sort                        *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define MAXLIST 200
#define TRUE 1
#define FALSE 0

int nodes[MAXLIST];

void mergesort(int nodes[], int n)
{
   int i, j, k, low1, up1, low2, up2, size;
   int dstam[MAXLIST];
   size = 1;
   while(size < n)
   {
      low1 = 0;
      k = 0;
      while(low1+size < n)
      {
	      low2 = low1+size;
	      up1 = low2-1;
	      up2 = (low2+size-1 < n) ? low2+size-1 : n-1;
	      for(i = low1, j = low2; i <= up1 && j <= up2; k++)
	         if(nodes[i] <= nodes[j])
	            dstam[k] = nodes[i++];
	         else
	            dstam[k] = nodes[j++];
	      for(; i <= up1; k++)
	         dstam[k] = nodes[i++];
	      for(; j <= up2; k++)
	         dstam[k] = nodes[j++];
	      low1 = up2+1;
      }
      for(i = low1; k < n; i++)
	      dstam[k++] = nodes[i];
      for(i = 0; i < n; i++)
	      nodes[i] = dstam[i];
      size *= 2;
   }
}

// Chuong trinh chinh
void main()
{
   int chucnang;
   char c;

   clrscr();

   do
   {
      // menu chinh cua chuong trinh
      printf("\n\n\tMERGE SORT");
      printf("\n\nCac chuc nang cua chuong trinh:\n");
      printf("   1: Tao danh sach voi %d so ngau nhien\n", MAXLIST);
      printf("   2: Merge Sort\n");
      printf("   3: Duyet danh sach\n");
      printf("   0: Ket thuc chuong trinh\n");
      printf("Chuc nang ban chon: ");
      scanf("%d", &chucnang);
      switch(chucnang)
      {
	      case 1:
	      {
	         for(int i = 0; i < MAXLIST; i++)
	            nodes[i] = random(1000);
	         printf("\nDa tao xong danh sach voi %d so ngau nhien", MAXLIST);
	         break;
	      }
	      case 2:
	      {
	         mergesort(nodes, MAXLIST);
	         printf("\nDa sap xep xong danh sach theo giai thuat Merge Sort");
	         break;
	      }
	      case 3:
	      {
	         printf("\nDUYET DANH SACH:\n");
	         for(int i = 0; i < MAXLIST; i++)
	            printf("%4d", nodes[i]);
	         break;
	      }
      }
   } while(chucnang != 0);
}