/*****************************************************************************
* Chuong trinh C1-2: Chuong trinh thap Hanoi                                 *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <conio.h>

void hanoi(int, char, char, char);

void main()
{
   int n;
   char c;
   clrscr();
   do
   {
      printf("\n\nNhap so dia: ");
      scanf("%d", &n);
      printf("Cac buoc chuyen dia:");
      hanoi(n, 'A', 'C', 'B');
      printf("\n\nTiep tuc khong? (c/k): ");
      c = getche();
   } while(c == 'C' || c == 'c');
}

void hanoi(int n, char cotA, char cotC, char cotB)
{
   if(n == 1)
   {
      printf("\n%s%c%s%c", "   chuyen dia 1 tu cot ", cotA, " den cot ", cotC);
      return;
   }
   hanoi(n-1, cotA, cotB, cotC);
   printf("\n%s%d%s%c%s%c", "   chuyen dia ", n, " tu cot ", cotA, " den cot ", cotC);
   hanoi(n-1, cotB, cotC, cotA);
}