/*****************************************************************************
* Chuong trinh C2-2: Chuong trinh doi co so, co cai dat stack                *
* Nguoi viet chuong trinh: Nguyen Hong Chuong                                *
* Ngay cap nhat moi nhat: 15/3/1999                                          *
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define STACKSIZE 100
#define TRUE 1
#define FALSE 0

struct stack
{
   int top;
   int nodes[STACKSIZE];
};

int empty(struct stack *ps)
{
   if(ps->top == -1)
      return(TRUE);
   else
      return(FALSE);
}

void push(struct stack *ps, int x)
{
   if(ps->top == STACKSIZE-1)
   {
      printf("%s", "stack bi day");
      exit(1);
   }
   else
      ps->nodes[++(ps->top)] = x;
}

int pop(struct stack *ps)
{
   if(empty(ps))
   {
      printf("%s", "stack bi rong");
      exit(1);
   }
   return(ps->nodes[ps->top--]);
}

main()
{
   struct stack s;
   int coso, so, sodu;
   char c;
   clrscr();

   do
   {
      s.top =- 1;  // khoi dong stack

      printf("\n\nNhap vao mot so thap phan: ");
      scanf("%d", &so);
      printf("%s","Muon doi so thap phan nay sang co so may: ");
      scanf("%d", &coso);

      while (so != 0)
      {
	      sodu = so % coso;
	      push(&s, sodu);  // push so du vao stack
	      so = so / coso;
      }

      printf("So da doi la: ");
      while(!empty(&s))
	      printf("%X", pop(&s));  // pop so du ra khoi stack

      printf("\n\nBan co muon tiep tuc khong? (c/k): ");
      c = getche();
   } while(c == 'c' || c == 'C');
}